//makeProfileTimer

//var t0 = performance.now();
//alert('Замеряем время работы этого alert');
//var t1 = performance.now();
//alert("врем выполнения makeProfileTimer " + (t1 - t0) + " миллисекунд.")

let makeProfileTimer = function() {
    let t1 = performance.now();
      return function() {
      return performance.now() - t1
    };
  };
  let timer = makeProfileTimer()
  alert('Замеряем время работы этого alert');
  alert(`время выполнения makeProfileTimer до момента вызова timer() ${timer()} миллисекунд`);

// makeSaver

let makeSaver = function (func) {
    let param = true;
    let result;
    return function () {
        if (param) {
            result = func();
            param = false;
        }
        return result;
    };
};
    
    var saver = makeSaver(Math.random) //создает функцию-хранилище результата переданной в качестве параметра функции (Math.random 
                                      // в примере). На этом этапе Math.random НЕ вызывается
    var value1 = saver()              //saver вызывает переданную в makeSaver функцию, запоминает результат и возвращает его
    var value2 = saver()              //saver в дальнейшем просто хранит результат функции, и более НЕ вызывает переданную 
                                      //в makeSaver функцию;
    value1 === value2                 // всегда true

    var saver2 = makeSaver(() => console.log('saved function called') || [null, undefined, false, '', 0, Math.random()][Math.ceil(Math.random()*6)])
    var value3 = saver2()
    var value4 = saver2()

    value3 === value4 // тоже должно быть true

// Final Countdown

let counter = function (num) {
    setTimeout(() => console.log(num), 0);
        for (let i = num - 1; i > 0; i--) {
            setTimeout(() => console.log(num - i), i * 1000)
     }
    setTimeout(() => console.log('поехали!'), num * 1000)
   }
counter(5)

// myBind

function myBind (fn, context, array) {
    return function(...args) {
        let i = 0;
        let newArray = array.map((value) => (value === undefined ? args[i++] : value))
        return fn.call(context, ...newArray)
    }
}

var pow5 = myBind(Math.pow, Math, [undefined, 5]) // первый параметр - функция для биндинга значений по умолчанию, 
   // второй - this для этой функции, третий - массив, в котором undefined означает
 // параметры, которые должны передаваться при вызове,
 // а другие значения являются значениями по умолчанию:
var cube = myBind(Math.pow, Math, [undefined, 3]) // cube возводит число в куб

pow5(2) // => 32, вызывает Math.pow(2,5), соотнесите с [undefined, 5]
cube(3) // => 27

var chessMin = myBind(Math.min, Math, [undefined, 4, undefined, 5,undefined, 8,undefined, 9])
chessMin(-1,-5,3,15) // вызывает Math.min(-1, 4, -5, 5, 3, 8, 15, 9), результат -5

var zeroPrompt = myBind(prompt, window, [undefined, "0"]) // аналогично, только теперь задается "0" как текст по умолчанию в prompt, 
           // а текст приглашения пользователя задается при вызове zeroPrompt
var someNumber = zeroPrompt("Введите число")              // вызывает prompt("Введите число","0")

myBind((...params) => params.join(''), null, [undefined, 'b', undefined, undefined, 'e', 'f'])('a','c','d') === 'abcdef'
