// Напишите функцию конструктор Password, которая будет в родительском элементе создавать поле ввода для пароля и кнопку/иконку/чекбокс, который будет переключать режим просмотра пароля в поле ввода.
// Параметры:
// parent - родительский элемент
// open - стартовое состояние
// Методы:
// setValue/getValue - задают/читают значения
// setOpen/getOpen - задают/читают открытость текста в поле ввода
// Колбэки (функции обратного вызова, данные изнутри объекта):
// onChange - запускается по событию oninput в поле ввода, передает текст наружу
// onOpenChange - запускается по изменению состояния открытости пароля

//Password
    
function Password(parent, open = false) {
    let inpPass = document.createElement("input")
    let checkBox = document.createElement("input")
    checkBox.setAttribute("type", "checkbox")
    if (open) checkBox.setAttribute("checked", "checked");
    let text = document.createElement("span")
    text.innerText = ("view")

    this.setValue = function(value) {
        inpPass.value = value
    }

    this.getValue = function() {
        return inpPass.value
    }

    var test = () => 
      checkBox.checked ? (inpPass.type = "text") : (inpPass.type = "password");

    this.setOpen = function() {
       checkBox.checked
       test()
    }

    this.getOpen = function() {
        return checkBox.checked
    }

    inpPass.oninput = () => {
      this.onChange()
      }

    checkBox.onclick = () => {
        test()
        this.onOpenChange(checkBox.checked)
    }
    
    parent.append(inpPass)
    parent.append(checkBox)
    parent.append(text)

}

let p = new Password(document.body, true)

p.onChange = () => console.log(p.getValue())
p.onOpenChange = (open) => console.log(open)

p.setValue('qwerty')
console.log(p.getValue())

// LoginForm

// С помощью предыдущего кода Password сделайте форму логина, кнопка в которой будет активна
// только если и login и пароль не пусты


let div = document.createElement("div")
document.body.append(div)

let login = new Password(div, true) 
  div.querySelector(`input[type="checkbox"]`).remove()
  div.querySelector("span").remove()

let newPassword = new Password(div, true)

let button = document.createElement("button")
button.innerText = "Send"
document.body.append(button)
button.setAttribute("disabled", "disabled")

login.onChange = newPassword.onChange = () => {
  if (login.getValue && newPassword.getValue) {
    button.removeAttribute("disabled")
  }
  else button.setAttribute("disabled", "disabled")
}

newPassword.setValue('qwerty') 
newPassword.onOpenChange = (open) => console.log(open)

// LoginForm Constructor

//оформите предыдущую задачу как функцию-конструктор. Продумайте и предусмотрите геттеры, сеттеры и колбэки.


// LoginForm Constructor
// оформите предыдущую задачу как функцию - конструктор.
// Продумайте и предусмотрите геттеры, сеттеры и колбэки.
// Password Verify
// С помощью Password сделайте пару инпутов, которые проверяют введеный пароль (в двух полях ввода) на совпадение. Кнопка должна активизироваться при совпадающих паролях. При открытом пароле второе поле вводы должно пропадать с экрана Таким образом:
// Когда Password в скрытом режиме - появляется второй инпут (<input type='password'>) с паролем в скрытом режиме
// Когда Password в открытом режиме - второй инпут пропадат

function NewForm (parent, open = false) {
    div = document.createElement("div")
    this.inp = document.createElement("input")
    this.inp.setAttribute('type', open ? 'text' : 'password')
    div.append(this.inp)
    parent.append(div)
    return this.inp
}

function LoginPass (parent) {
    let form = document.createElement("div")

    let login = new NewForm (form, true)
    login.setAttribute("placeholder", "login")
    login.oninput = () => this.onChange()
    this.setValueLogin = function(value) {
        login.value = value
    }

    this.getValueLogin = function() {
        return login.value
    }

    let pass_1 = new NewForm (form, false)
    pass_1.setAttribute("placeholder", "password")
    pass_1.oninput = () => this.onChange()

    let pass_2 = new NewForm (form, false)
    pass_2.setAttribute("placeholder", "veryfi password")
    pass_2.oninput = () => this.onChange()

    let check = new NewForm (form, false)
    check.setAttribute("type", "checkbox")
    check.onchange = () =>  {
        if(check.checked) {
            pass_1.setAttribute("type", "text")
            pass_2.style.display = "none"
        }
        else{
            pass_1.setAttribute("type", "password")
            pass_2.style.display = "block"
            check.oninput = () => this.onChange()
        }
        this.onChange()
    }
    check.parentElement.append("View")

    let button = document.createElement("button");
    button.append("Login");
    button.setAttribute("disabled", "disabled");

    form.append(button);

    this.onChange = () => {  
      if(check.checked &&
          login.value != "" && 
          pass_1.value != "") {
            button.removeAttribute("disabled", "disabled");
          }
      if(login.value != "" && 
      pass_1.value != "" &&
      pass_2.value === pass_1.value) {
            button.removeAttribute("disabled", "disabled");
      }
      else{
        button.setAttribute("disabled", "disabled")
    }
        
    }
    parent.append(form)
}
let Registration = new LoginPass (document.body)
Registration.setValueLogin('qwerty')