// let cats = document.getElementById("cats")
//             let li = document.createElement("li")
//             li.innerHTML = "privet"
//             cats.append(li)


const gql = 'http://shop-roles.asmer.fs.a-level.com.ua/graphql'

const getGQL = url => 
    (query, variables={}) => 
        fetch(url, 
            {method: 'POST', 
                headers: {
                  'Accept': 'application/json',
                  'Content-Type': 'application/json',
                  ...(localStorage.authToken ? {Authorization: `Bearer ${localStorage.authToken}`} : {})
                },
                body: JSON.stringify({query,variables})})
        .then(res => res.json())

async function categories(cats = document.getElementById("cats"), parentId=null){
  let result = await gql(`query categories($query:String){
                                CategoryFind(query: $query){
                                  _id
                                  name,
                                  goods{
                                    name
                                  },
                                  parent{
                                    name
                                  }
                                }
  }`, {query: JSON.stringify([{"parent._id": parentId}])})
  if (result.errors) return;
  //cats = document.getElementById("cats")
  for (let {name, _id} of result.data.CategoryFind){
      let li = document.createElement('li')
      li.innerText = name
      let loaded;
      li.onclick   = () => { 
          if (!loaded) { 
              categories(li,_id) 
              loaded = true
          }
      }
      cats.append(li)
  }
}

categories()

///////////////////////////////////////////////////
        

    function LoginForm(el){
        const loginInput = document.createElement('input') 
        loginInput.type = 'text'

        const passwordInput = document.createElement('input') 
        passwordInput.type = 'password'

        const btn = document.createElement('button') 
        btn.innerText = 'Login'

        el.append(loginInput)
        el.append(passwordInput)
        el.append(btn)

        btn.onclick = () => {
            if (this.onlogin){
                this.onlogin(loginInput.value, passwordInput.value)
            }
        }

        this.setLogin    = newLogin => loginInput.value = newLogin
        this.setPassword = newPassword => passwordInput.value = newPassword

        this.getLogin    = () => loginInput.value
        this.getPassword = () => passwordInput.value

    }




    const form = new LoginForm(document.body)
    console.log(form)

    form.setLogin('admin')
    form.setPassword('password')

    form.onlogin = async (login, password) => {
        let result = await gql(`query login($login:String, $password:String){
              login(login:$login,password:$password)
        }`, {login, password})
//        console.log(result)
        if (result.errors) return;
        localStorage.authToken = result.data.login
    }

    async function categories(el=aside, parentId=null){
        let result = await gql(`query cats($query:String){
                                      CategoryFind(query: $query){
                                        _id
                                        name,
                                        goods{
                                          name
                                        },
                                        parent{
                                          name
                                        }
                                      }
        }`, {query: JSON.stringify([{"parent._id": parentId}])})
        if (result.errors) return;
        let ul = document.createElement('ul')
        el.append(ul)
        for (let {name, _id} of result.data.CategoryFind){
            let li = document.createElement('li')
            li.innerText = name
            let loaded;
            li.onclick   = () => { 
                if (!loaded) { 
                    categories(li,_id) 
                    loaded = true
                }
            }
            ul.append(li)
        }
    }

    categories()


  //   document.body.onclick = function(e){
  //       console.log('БАДИ КЛИК', e)
  //   }
  //  container1.onclick = function(e){
  //       console.log('СПРЯТАННЫЙ КЛИК', e)
  //      e.stopImmediatePropagation()
  //      //e.stopPropagation()
  //   }
    // container1.addEventListener('click', function(e){
    //     console.log('СПРЯТАННЫЙ КЛИК 2', e))}