// sort

var persons = [
    {name: "Иван", age: 17},
    {name: "Мария", age: 35},
    {name: "Алексей", age: 73},
    {name: "Яков", age: 12},
]

sort = function (arr, key, parameter = true) {
    if (parameter) {
        arr.sort(function (a, b) {
            return (a[key] > b[key]) - (a[key] < b[key])
        });
    } else
        arr.sort(function (a, b) {
            return (a[key] < b[key]) - (a[key] > b[key])
        });
    return arr;
};

console.log(sort(persons, "age"))
console.log(sort(persons, "name", false))

// array map

let array = ["1", {}, null, undefined, "500", 700]
let newArray = array.map(function (number) {
    if (!number === false && !isNaN(+number)) {
        return +number
    }

    return number

})
console.log(newArray)

// array reduce

var Array = ["0", 5, 3, "string", null]

var result = Array.reduce(function(a, b){
    if(typeof(b)==='number'){
        a*=b
    }
    return a
 }, 1)

console.log(result);

//object filter

var phone = {
    brand: "meizu",
    model: "m2",
    ram: 2,
    color: "black",
};

function filter(obj, funk) {
    let newObj = {}
    for (let key in obj){
        if (funk(key, obj[key])){
            newObj[key] = obj[key]
        }
    }
    return newObj
}
console.log(filter(phone,(key,value) => key == "color" || value == 2));

// object map

function map(object, callback){
    var obj = {};
        for(var key in object)  
            Object.assign(obj,callback(key, object[key]));
          return obj
    }
    
    var obj = map({name: "Иван", age: 17}, function(key, value){
      var result = {};
      result[key+"_"] = value + "$";
      return result;
    })
    console.log(obj);

// Рекурсия
// sum

function sumRecurs(n) {
    if (n == 1) return 1;
    return n + sumRecurs(n - 1);
  }
  
  console.log(sumRecurs(555))

// HTML Tree

var someTree = {
    tagName: "table", //html tag
    children: [ //вложенные тэги
        {
                    tagName: "tr",
                    children: [
                        {
                            tagName: "td",
                            text: "some text",
                        },
                        {
                            tagName: "td",
                            text: "some text 2",
                        }
                    ]
        }
    ],
    attrs: 
    {
        border: 1,
    },
}

let creater = function (item) {
    let list = document.createElement(item.tagName);
    if ("attrs" in item) {
        for (attrKey in item.attrs) {
            list.setAttribute(attrKey, item.attrs[attrKey]);
        }
    }

    if ("subTags" in item) {
        for (i in item.subTags) {
            list.append(creater(item.subTags[i]));
        }
    }

    if ("text" in item) {
        list.innerText = item.text;
    }
    return list;
};

console.log(creater(someTree));

