function myfetch(url){
    return new Promise(function (resolve, reject){
        const xhr = new XMLHttpRequest()
        xhr.open('GET', url)
        xhr.send()
        xhr.onload = function() {
            if (xhr.status != 200) { 
                reject(`Ошибка ${xhr.status}: ${xhr.statusText}`)
                return
            } 
            resolve(JSON.parse(xhr.response))
        }
        xhr.onerror = function() {
            reject("Error")
        }
    })
}

myfetch('https://swapi.dev/api/people/1/')
  .then(luke => console.log(luke))

let delay = function (ms) {
    return new Promise(function (resolve) {
        setTimeout(() => resolve(`Delay ${ms}`), ms)
    })
}

Promise.race([delay(1000), myfetch("https://swapi.dev/api/people/1/")])
.then(res => console.log(res));

